/*
 * Copyright (c) 2001 Massachusetts Institute of Technology.
 *
 * This file is part of VideoCM. 
 *
 * This software is being provided by the copyright holders under the GNU
 * General Public License, either version 2 or, at your discretion, any later
 * version. (See the file `COPYING' in the source distribution.)
 *
 * This software is provided "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
 * EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. The entire risk as
 * to the quality and performance of the program is with you. See the GNU
 * General Public License for more details.
 *
 * The name and trademarks of copyright holders may NOT be used in 
 * advertising or publicity pertaining to the software without specific, 
 * written prior permission. Title to copyright in this software and any 
 * associated documentation will at all times remain with copyright 
 * holders. See the file AUTHORS which should have accompanied this software 
 * for a list of all copyright holders. 
 * 
 * Particular files in this distribution may be derived from previously
 * copyrighted software. This copyright applies only to those changes made by
 * the copyright holders listed in the AUTHORS file.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 */


/*
 *  resync.cc
 *  Nick Feamster (feamster@lcs.mit.edu)
 *  MIT Lab for Computer Science
 *  created January 2001
 */


#ifndef __RESYNC_H__
#define __RESYNC_H__

#include <sys/types.h>
#include <sys/stat.h>
#include <netinet/in.h>
#include <fcntl.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <math.h>

#ifndef __MOMUSYS__
#define __MOMUSYS__
extern "C" {
#include "momusys.h"
#include "io_generic.h"
#include "mom_structs.h"
#include "vm_common_defs.h"
#include "mom_bitstream_d.h"
}
#endif


#define RESYNCH_MARKER 0x000001
#define GOB_RESYNC_MARKER         0x01 
#define GOB_RESYNC_MARKER_LENGTH  17   
#define RESYNC_MARKER           1           /* 26.04.97 LDS: according to VM6.0 */
#define RESYNC_MARKER_LENGTH    17

#define PACKET_SIZE 8*40*1024

#define I_VOP 0
#define P_VOP 1
#define B_VOP 2

#endif
