/******************************************************************
 *
 * Nick Feamster
 * MIT LCS
 * September 2000
 * mergeyuv.c -- split concatenated YUV 4:2:0 into separate frames
 *
 ******************************************************************/

#include <stdio.h>

void usage(char *name) {
  printf ("%s <filename> <width> <height> <start-index> <stop-index>\n", name);
}

int mergeYUV420(char *filename, int width, int height, int start, int stop) {

  FILE *fp;
  FILE *fpi;
  char infilename[80];
  char outfilename[80];
  int i;
  int filesize = width*height + (width*height/2);
  char *buf = (char*)malloc(filesize*sizeof(char));
  sprintf(outfilename, "%s.yuv", filename);

  fp = fopen(outfilename, "wb");
  if (!fp) {
    fprintf(stderr, "error opening file: %s\n", outfilename);
    return -1;
  }


  for (i=start; i<stop; i++) {
    sprintf(infilename, "%s%.3d.yuv", filename, i);
    fpi = fopen(infilename, "rb");
    fread(buf, sizeof(char), filesize, fpi);

    if (!fpi) {
      fprintf(stderr, "error opening file: %s\n", infilename);
      return -1;
    }
    fwrite(buf, sizeof(char), filesize, fp);    
    close(fpi);

  }

  close(fp);

}


int main(int argc, char **argv) {

  if (argc < 5) {
    usage(argv[0]);
    return;
  }

  mergeYUV420(argv[1], atoi(argv[2]), atoi(argv[3]), atoi(argv[4]), atoi(argv[5]));

}
