/******************************************************************
 *
 * Nick Feamster
 * MIT LCS
 * August 2000
 * pix2rgb.c
 *
 ******************************************************************/

#include <stdio.h>

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/X.h>
#include <X11/Xatom.h>


int short2byte(short pix) {
  return (int)((unsigned short)pix/(double)65536 * 256);
}


int
XImage2RGB(char *in_filename, char *out_filename) {
  
  Display *dpy;
  int screen;
  int req_xoffset, req_yoffset;

  static int image_no = 0;
  int cc, status;


  XImage *image;
  register XImage *ximage;
  XStandardColormap cminfo;
  XStandardColormap *cmip = &cminfo;

  char *data;
  XColor pixcolor;
  Colormap cmap;
  long i, j;

  FILE *fp, *fp2;

  image = (XImage*)malloc(sizeof(XImage));
 
  /* connect to X server */
  if ((dpy = XOpenDisplay(NULL)) == NULL) {
    fprintf(stderr, "error: cannot connect to X server %s\n",
	    XDisplayName(NULL));
  }

  screen = DefaultScreen(dpy);

/*    cc = XGetStandardColormap(dpy,DefaultRootWindow(dpy), */
/*  		       &cminfo, XA_RGB_BEST_MAP); */
/*    cc = XGetRGBColormaps(dpy,RootWindow(dpy,screen), */
/*  		       &cmip, &status, XA_RGB_BEST_MAP); */

/*    if (!cc) { */
/*      printf("ALERT: specified standard colormap not available!\n"); */
/*    } */

/*    cmap = cminfo.colormap; */
  cmap = DefaultColormap(dpy,screen);
  fp = fopen(in_filename, "rb");

  while (!feof(fp)) {

    char outfile[80];
    sprintf(outfile, "%s%.3d.rgb", out_filename, image_no++);
    
    fp2 = fopen(outfile, "wb");

    fread(&(req_xoffset), sizeof(int), 1, fp);
    fread(&(req_yoffset), sizeof(int), 1, fp);
    
    fread(&(image->width), sizeof(int), 1, fp);
    fread(&(image->height), sizeof(int), 1, fp);
    fread(&(image->xoffset), sizeof(int), 1, fp);
    fread(&(image->format), sizeof(int), 1, fp);
    fread(&(image->byte_order), sizeof(int), 1, fp);
    fread(&(image->bitmap_unit), sizeof(int), 1, fp);
    fread(&(image->bitmap_bit_order), sizeof(int), 1, fp);
    fread(&(image->bitmap_pad), sizeof(int), 1, fp);
    fread(&(image->depth), sizeof(int), 1, fp);
    fread(&(image->bytes_per_line), sizeof(int), 1, fp);
    fread(&(image->bits_per_pixel), sizeof(int), 1, fp);
    fread(&(image->red_mask), sizeof(unsigned long), 1, fp);
    fread(&(image->green_mask), sizeof(unsigned long), 1, fp);
    fread(&(image->blue_mask), sizeof(unsigned long), 1, fp);



    image->data = (char*)malloc(image->height*image->bytes_per_line);
    cc = fread(image->data, sizeof(char),
	       image->height*image->bytes_per_line, fp);

    printf("width: %d, height: %d, \nxoffset: %d, format: %d, \nbyte_order: %d, bitmap_unit: %d, bitmap_bit_order: %d, bitmap_pad: %d, \ndepth: %d, bytes_per_line: %d, bits_per_pixel: %d, \nred_mask: %lx, green_mask: %lx, blue_mask: %lx\n, wrote frame of size: %d bytes\n\n",
	    image->width, image->height, image->xoffset, image->format,
	    image->byte_order, image->bitmap_unit, image->bitmap_bit_order,
	    image->bitmap_pad, image->depth, image->bytes_per_line,
	    image->bits_per_pixel,
	    image->red_mask, image->green_mask,image->blue_mask,
	    cc);



    if (!cc) {
      fprintf(stderr, "ERROR: no bytes read from file: %d\n", ferror(fp));
      continue;
    } else {
      fprintf(stderr, "read %d bytes from file\n", cc);
    }

    ximage = XCreateImage(dpy, DefaultVisual(dpy,screen), image->depth,
			  image->format, image->xoffset, image->data,
			  image->width, image->height,
			  image->bitmap_pad, image->bytes_per_line);
      
    for (j=0; j<ximage->height; j++) {
      for (i=0; i<ximage->width; i++) {
	pixcolor.pixel = XGetPixel(ximage, i, j);
	XQueryColor(dpy, cmap, &pixcolor);
/*  	fwrite(&(pixcolor.red), sizeof(short), 1, fp2); */
/*  	fwrite(&(pixcolor.green), sizeof(short), 1, fp2);  */
/*  	fwrite(&(pixcolor.blue), sizeof(short), 1, fp2); */
	
	pixcolor.red = short2byte(pixcolor.red);
	pixcolor.green = short2byte(pixcolor.green);
	pixcolor.blue = short2byte(pixcolor.blue);
	fwrite(&(pixcolor.red), sizeof(char), 1, fp2);
	fwrite(&(pixcolor.green), sizeof(char), 1, fp2); 
	fwrite(&(pixcolor.blue), sizeof(char), 1, fp2);



	fflush(fp2);
      }
    }
/*      XDestroyImage(ximage); */
    free(ximage);
    free(image->data);
  }

  
  free(image);
  
  fclose(fp);
  fclose(fp2);

}


int
main(int argc, char **argv) {
  XImage2RGB(argv[1], argv[2]);
}
