/******************************************************************
 *
 * Nick Feamster
 * MIT LCS
 * September 2000
 * splityuv.c -- split concatenated YUV 4:2:0 into separate frames
 *
 ******************************************************************/

#include <stdio.h>

void usage(char *name) {
  printf ("%s <filename> <width> <height> <start-index>\n", name);
}

int splitYUV420(char *filename, int width, int height, int start) {

  FILE *fp = fopen(filename, "rb");
  FILE *fpo;
  char outfilename[80];

  int filesize = width*height + (width*height/2);
  char *buf = (char*)malloc(filesize*sizeof(char));

  if (!fp) {
    fprintf(stderr, "error opening file: %s\n", filename);
    return -1;
  }

  while (!feof(fp)) {
    char *pre = (char*)strtok(filename, ".");
    sprintf(outfilename, "%s%.3d.yuv", pre, start++);
    fpo = fopen(outfilename, "wb");

    fprintf(stderr, "outputting to: %s\n", outfilename);

    if (!fpo) {
      fprintf(stderr, "error opening file: %s\n", outfilename);
      return -1;
    }
    
    fread(buf, sizeof(char), filesize, fp);
    fwrite(buf, sizeof(char), filesize, fpo);
    close(fpo);
  }
    

}


int main(int argc, char **argv) {

  if (argc < 5) {
    usage(argv[0]);
    return;
  }

  splitYUV420(argv[1], atoi(argv[2]), atoi(argv[3]), atoi(argv[4]));

}
